//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//
//      FNKeyboard.cpp
//

#include "FNKeyboard.hpp"
#include "FSKeyboard.hpp"
#include "TNKeyboard.hpp"

FNKeyboard::FNKeyboard(SFRApplicationPtr director, SFXRectangleConstRef rect, MonitorPtr monitor, CalculatorPtr calculator) static_throws : Keyboard(director, rect, ATTRIBUTE_FNKEYBOARD, monitor, calculator)
{
    if (static_try()) {
        Refresh();
    }
    return;
}

FNKeyboardPtr FNKeyboard::GetInstance(Void)
{
    return static_cast<FNKeyboardPtr>(Keyboard::GetInstance(ATTRIBUTE_FNKEYBOARD));
}

Void FNKeyboard::HandlerClear(Void)
{
    Return();
    return;
}

Void FNKeyboard::Handler1(Void)
{
    GetCalculator()->Function_int();
    Return();
    return;
}

Void FNKeyboard::Handler2(Void)
{
    GetCalculator()->Function_fix();
    Return();
    return;
}

Void FNKeyboard::Handler3(Void)
{
    GetCalculator()->Function_sqrt();
    Return();
    return;
}

Void FNKeyboard::Handler4(Void)
{
    GetCalculator()->Function_xy();
    Return();
    return;
}

Void FNKeyboard::Handler5(Void)
{
    GetCalculator()->Function_log();
    Return();
    return;
}

Void FNKeyboard::Handler6(Void)
{
    GetCalculator()->Function_ln();
    Return();
    return;
}

Void FNKeyboard::Handler7(Void)
{
    GetCalculator()->Function_fact();
    Return();
    return;
}

Void FNKeyboard::Handler8(Void)
{
    GetCalculator()->Function_nCr();
    Return();
    return;
}

Void FNKeyboard::Handler9(Void)
{
    GetCalculator()->Function_jn();
    Return();
    return;
}

Void FNKeyboard::HandlerStar(Void)
{
    Return();
    return;
}

Void FNKeyboard::Handler0(Void)
{
    KeyboardPtr keyboard;

    if ((keyboard = TNKeyboard::GetInstance()) != null) {
        keyboard->Activate(this);
    }
    return;
}

Void FNKeyboard::HandlerPound(Void)
{
    KeyboardPtr keyboard;

    if ((keyboard = FSKeyboard::GetInstance()) != null) {
        keyboard->Activate(this);
    }
    return;
}

Void FNKeyboard::Refresh(Void)
{
    static MapRecConst map = {{
        {        MAP_UNDEFINED,               MAP_RTN,                MAP_OFF},
        {{"int", COLOR_NORMAL}, {"fix", COLOR_NORMAL}, {"sqrt", COLOR_NORMAL}},
        {{"x^y", COLOR_NORMAL}, {"log", COLOR_NORMAL}, {  "ln", COLOR_NORMAL}},
        {{ "x!", COLOR_NORMAL}, {"nCr", COLOR_NORMAL}, {  "jn", COLOR_NORMAL}},
        {              MAP_VAL,               MAP_TRI,                MAP_SFT}
    }};

    Keyboard::Refresh(map);
    return;
}

Void FNKeyboard::Activate(KeyboardPtr inactivate)
{
    Keyboard::Activate(inactivate, Monitor::MODE_FUNCTION);
    return;
}
