//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      FNKeyboard.hpp
//

#ifndef __SOPHIACRADLE_FNKEYBOARD_HPP
#define __SOPHIACRADLE_FNKEYBOARD_HPP

#include <SophiaFramework.hpp>
#include "Keyboard.hpp"

SFMRESPONDERATTRIBUTE(FNKEYBOARD, four_char_code('F', 'N', 'k', 'y'))

SFMTYPEDEFCLASS(FNKeyboard)

class FNKeyboard : public Keyboard {

    SFMSEALCOPY(FNKeyboard)

    public:

        explicit FNKeyboard(SFRApplicationPtr director, SFXRectangleConstRef rect, MonitorPtr monitor, CalculatorPtr calculator) static_throws;
        static FNKeyboardPtr GetInstance(Void);

    private:

        virtual Void HandlerClear(Void);
        virtual Void Handler1(Void);
        virtual Void Handler2(Void);
        virtual Void Handler3(Void);
        virtual Void Handler4(Void);
        virtual Void Handler5(Void);
        virtual Void Handler6(Void);
        virtual Void Handler7(Void);
        virtual Void Handler8(Void);
        virtual Void Handler9(Void);
        virtual Void HandlerStar(Void);
        virtual Void Handler0(Void);
        virtual Void HandlerPound(Void);
        virtual Void Refresh(Void);
        virtual Void Activate(KeyboardPtr inactivate);
};

#endif // __SOPHIACRADLE_FNKEYBOARD_HPP //
