//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      FSKeyboard.hpp
//

#ifndef __SOPHIACRADLE_FSKEYBOARD_HPP
#define __SOPHIACRADLE_FSKEYBOARD_HPP

#include <SophiaFramework.hpp>
#include "Keyboard.hpp"

SFMRESPONDERATTRIBUTE(FSKEYBOARD, four_char_code('F', 'S', 'k', 'y'))

SFMTYPEDEFCLASS(FSKeyboard)

class FSKeyboard : public Keyboard {

    SFMSEALCOPY(FSKeyboard)

    public:

        explicit FSKeyboard(SFRApplicationPtr director, SFXRectangleConstRef rect, MonitorPtr monitor, CalculatorPtr calculator) static_throws;
        static FSKeyboardPtr GetInstance(Void);

    private:

        virtual Void HandlerClear(Void);
        virtual Void Handler1(Void);
        virtual Void Handler2(Void);
        virtual Void Handler3(Void);
        virtual Void Handler4(Void);
        virtual Void Handler6(Void);
        virtual Void Handler7(Void);
        virtual Void Handler8(Void);
        virtual Void Handler9(Void);
        virtual Void HandlerStar(Void);
        virtual Void Handler0(Void);
        virtual Void HandlerPound(Void);
        virtual Void Refresh(Void);
        virtual Void Activate(KeyboardPtr inactivate);
};

#endif // __SOPHIACRADLE_FSKEYBOARD_HPP //
