//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//     KeySequence.cpp
//

#include "KeySequence.hpp"
#include "Calculator.hpp"

SFXAnsiString KeyType::GetString(Void) const
{
    SFXAnsiString str;
    switch (_keyCode) {
        case KeyType::KEYCODE_NUMBER_0:
            str = "0";
            break;
        case KeyType::KEYCODE_NUMBER_1:
            str = "1";
            break;
        case KeyType::KEYCODE_NUMBER_2:
            str = "2";
            break;
        case KeyType::KEYCODE_NUMBER_3:
            str = "3";
            break;
        case KeyType::KEYCODE_NUMBER_4:
            str = "4";
            break;
        case KeyType::KEYCODE_NUMBER_5:
            str = "5";
            break;
        case KeyType::KEYCODE_NUMBER_6:
            str = "6";
            break;
        case KeyType::KEYCODE_NUMBER_7:
            str = "7";
            break;
        case KeyType::KEYCODE_NUMBER_8:
            str = "8";
            break;
        case KeyType::KEYCODE_NUMBER_9:
            str = "9";
            break;
        case KeyType::KEYCODE_NUMBER_A:
            str = "A";
            break;
        case KeyType::KEYCODE_NUMBER_B:
            str = "B";
            break;
        case KeyType::KEYCODE_NUMBER_C:
            str = "C";
            break;
        case KeyType::KEYCODE_NUMBER_D:
            str = "D";
            break;
        case KeyType::KEYCODE_NUMBER_E:
            str = "E";
            break;
        case KeyType::KEYCODE_NUMBER_F:
            str = "F";
            break;
        case KeyType::KEYCODE_CONSTANT_PI:
            str = "pi";
            break;
        case KeyType::KEYCODE_CONSTANT_E:
            str = "e";
            break;
        case KeyType::KEYCODE_CONSTANT_RAN:
            str = "Ran#";
            break;
        case KeyType::KEYCODE_UNIT_TERA:
            str = "T";
            break;
        case KeyType::KEYCODE_UNIT_GIGA:
            str = "G";
            break;
        case KeyType::KEYCODE_UNIT_MEGA:
            str = "M";
            break;
        case KeyType::KEYCODE_UNIT_KILO:
            str = "K";
            break;
        case KeyType::KEYCODE_UNIT_MILLI:
            str = "m";
            break;
        case KeyType::KEYCODE_UNIT_MICRO:
            str = "u";
            break;
        case KeyType::KEYCODE_UNIT_NANO:
            str = "n";
            break;
        case KeyType::KEYCODE_UNIT_PICO:
            str = "p";
            break;
        case KeyType::KEYCODE_UNIT_FEMTO:
            str = "f";
            break;
        case KeyType::KEYCODE_FLOAT_POINT:
            str = ".";
            break;
        case KeyType::KEYCODE_FLOAT_EXP:
            str = "E";
            break;
        case KeyType::KEYCODE_PARENTHESIS_LEFT:
            str = "(";
            break;
        case KeyType::KEYCODE_PARENTHESIS_RIGHT:
            str = ")";
            break;
        case KeyType::KEYCODE_MEMORY_ANS:
            str = "Ans";
            break;
        case KeyType::KEYCODE_OPERATOR_PLUS:
            str = "+";
            break;
        case KeyType::KEYCODE_OPERATOR_MINUS:
            str = "-";
            break;
        case KeyType::KEYCODE_OPERATOR_MUL:
            str = "*";
            break;
        case KeyType::KEYCODE_OPERATOR_DIV:
            str = "/";
            break;
        case KeyType::KEYCODE_OPERATOR_POW:
            str = "^";
            break;
        case KeyType::KEYCODE_OPERATOR_FACTORIAL:
            str = "!";
            break;
        case KeyType::KEYCODE_OPERATOR_MOD:
            str = " mod ";
            break;
        case KeyType::KEYCODE_OPERATOR_AND:
            str = " and ";
            break;
        case KeyType::KEYCODE_OPERATOR_OR:
            str = " ior ";
            break;
        case KeyType::KEYCODE_OPERATOR_XOR:
            str = " xor ";
            break;
        case KeyType::KEYCODE_OPERATOR_NOT:
            str = "not ";
            break;
        case KeyType::KEYCODE_OPERATOR_NPR:
            str = "nPr";
            break;
        case KeyType::KEYCODE_OPERATOR_NCR:
            str = "nCr";
            break;
        case KeyType::KEYCODE_FUNCTION_SEPARATOR:
            str = ", ";
            break;
        case KeyType::KEYCODE_FUNCTION_POW:
            str = "pow(";
            break;
        case KeyType::KEYCODE_FUNCTION_EXP:
            str = "exp(";
            break;
        case KeyType::KEYCODE_FUNCTION_LN:
            str = "ln(";
            break;
        case KeyType::KEYCODE_FUNCTION_LOG:
            str = "log(";
            break;
        case KeyType::KEYCODE_FUNCTION_SQRT:
            str = "sqrt(";
            break;
        case KeyType::KEYCODE_FUNCTION_CBRT:
            str = "cbrt(";
            break;
        case KeyType::KEYCODE_FUNCTION_SIN:
            str = "sin(";
            break;
        case KeyType::KEYCODE_FUNCTION_COS:
            str = "cos(";
            break;
        case KeyType::KEYCODE_FUNCTION_TAN:
            str = "tan(";
            break;
        case KeyType::KEYCODE_FUNCTION_ASIN:
            str = "asin(";
            break;
        case KeyType::KEYCODE_FUNCTION_ACOS:
            str = "acos(";
            break;
        case KeyType::KEYCODE_FUNCTION_ATAN:
            str = "atan(";
            break;
        case KeyType::KEYCODE_FUNCTION_SINH:
            str = "sinh(";
            break;
        case KeyType::KEYCODE_FUNCTION_COSH:
            str = "cosh(";
            break;
        case KeyType::KEYCODE_FUNCTION_TANH:
            str = "tanh(";
            break;
        case KeyType::KEYCODE_FUNCTION_ASINH:
            str = "asinh(";
            break;
        case KeyType::KEYCODE_FUNCTION_ACOSH:
            str = "acosh(";
            break;
        case KeyType::KEYCODE_FUNCTION_ATANH:
            str = "atanh(";
            break;
        case KeyType::KEYCODE_FUNCTION_ABS:
            str = "abs(";
            break;
        case KeyType::KEYCODE_FUNCTION_INT:
            str = "int(";
            break;
        case KeyType::KEYCODE_FUNCTION_FIX:
            str = "fix(";
            break;
        case KeyType::KEYCODE_FUNCTION_GAMMA:
            str = "gamma(";
            break;
        case KeyType::KEYCODE_FUNCTION_FRAC:
            str = "frac(";
            break;
        case KeyType::KEYCODE_FUNCTION_JN:
            str = "jn(";
            break;
        case KeyType::KEYCODE_FUNCTION_YN:
            str = "yn(";
            break;
    }
    return str;
}

//
// Omitted * is inserted.
//
SFCError KeySequence::Normalize(Void)
{
    SInt32 i;
    KeyType key, keyPrev;
    KeyType::KeyCode code, codePrev;
    SFCError result(SFERR_NO_ERROR);
    Bool flag;

    for (i = 1; i < GetSize(); ++i) {
        key = GetKeyType(i);
        code = key.GetKeyCode();
        keyPrev = GetKeyType(i - 1);
        codePrev = keyPrev.GetKeyCode();
        flag = false;
        if ((code & KeyType::KEYCLASS_UNIT) && (codePrev & KeyType::KEYCLASS_UNIT)) {
            result = Calculator::ERR_SYNTAX;
            break;
        }
        if ((code & KeyType::KEYCLASS_NUMBER) || (code == KeyType::KEYCODE_FLOAT_POINT)) {
            if ((codePrev & KeyType::KEYCLASS_CONSTANT) || (codePrev & KeyType::KEYCLASS_UNIT)
                || (codePrev == KeyType::KEYCODE_PARENTHESIS_RIGHT) || (codePrev & KeyType::KEYCLASS_MEMORY)) {
                flag = true;
            }
        }
        else if ((code & KeyType::KEYCLASS_CONSTANT) || (code & KeyType::KEYCLASS_UNIT)
                || (code == KeyType::KEYCODE_PARENTHESIS_LEFT) || (code & KeyType::KEYCLASS_MEMORY)
                || ((code & KeyType::KEYCLASS_FUNCTION) && (code != KeyType::KEYCODE_FUNCTION_SEPARATOR))) {
            if ((codePrev & KeyType::KEYCLASS_NUMBER) || (codePrev & KeyType::KEYCLASS_CONSTANT)
                || (codePrev & KeyType::KEYCLASS_UNIT) || (codePrev == KeyType::KEYCODE_FLOAT_POINT)
                || (codePrev == KeyType::KEYCODE_PARENTHESIS_RIGHT) || (codePrev & KeyType::KEYCLASS_MEMORY)) {
                flag = true;
            }
        }
        if (flag) {
            if ((result = Insert(i, KeyType(KeyType::KEYCODE_OPERATOR_SMUL))) != SFERR_NO_ERROR) {
                break;
            }
            else {
                ++i;    // Increment
            }
        }
    }
    return result;
}

SFXAnsiString KeySequence::GetString(Void) const
{
    SFXAnsiString str;
    SInt32 i;
    SInt32 size(GetSize());
    KeyType type;

    for (i = 0; i < size; ++i) {
        type = _keys.Get(i);
        str += type.GetString();
    }
    return str;
}

Cursor KeySequence::GetCorrectCursor(SInt16 position) const
{
    Cursor cursor;
    SInt16 head(0), foot(0), len(0);
    SInt32Const size(GetSize());
    SInt32 i;
    KeyType type;

    if (position < 0) {
        position = 0;
    }

    for (i = 0; i < size; ++i) {
        type = _keys.Get(i);
        len = type.GetLength();
        foot += len;
        if (position >= head && position < foot) {
            break;
        }
        head = foot;
    }
    cursor.Set(head, (i < size) ? len : 1);
    return cursor;
}

Cursor KeySequence::GetPreviousCursor(SInt16 position) const
{
    SInt16 head(0), headPrev(0), foot(0), len(1), lenPrev(1);
    SInt32 i;
    SInt32Const size(GetSize());
    KeyType type;

    if (position < 0) {
        position = 0;
    }

    for (i = 0; i < size; ++i) {
        type = _keys.Get(i);
        len = type.GetLength();
        foot += len;
        if (position >= head && position < foot) {
            if (i == 0) {
                lenPrev = len;
            }
            break;
        }
        headPrev = head;
        head = foot;
        lenPrev = len;
    }
    return Cursor(headPrev, lenPrev);
}

Cursor KeySequence::GetNextCursor(SInt16 position) const
{
    Cursor cursor;
    SInt16 head(0), foot(0);
    SInt32 i;
    SInt32Const size(GetSize());
    KeyType type;

    if (position < 0) {
        position = 0;
    }

    for (i = 0; i < size; ++i) {
        type = _keys.Get(i);
        foot += type.GetLength();
        if (position >= head && position < foot) {
            break;
        }
        head = foot;
    }
    if (++i < size) {
        type = _keys.Get(i);
        cursor.Set(foot, type.GetLength());
    }
    else {
        cursor.Set(foot, 1);
    }
    return cursor;
}

SInt32 KeySequence::GetIndex(SInt16 position) const
{
    SInt16 head(0), foot(0);
    SInt32 i;
    SInt32Const size(GetSize());
    KeyType type;

    if (position < 0) {
        position = 0;
    }

    for (i = 0; i < size; ++i) {
        type = _keys.Get(i);
        foot += type.GetLength();
        if (position >= head && position < foot) {
            break;
        }
        head = foot;
    }
    return i;
}

Cursor KeySequence::GetCursor(SInt32 index) const
{
    Cursor cursor;
    SInt16 pos(0);
    SInt32 i;
    SInt32Const size(GetSize());
    KeyType type;

    if (index > size) {
        index = size;
    }
    for (i = 0; i < index; ++i) {
        type = _keys.Get(i);
        pos += type.GetLength();
    };
    if (index < size) {
        type = _keys.Get(index);
        cursor.Set(pos, type.GetLength());
    }
    else {
        cursor.Set(pos, 1);
    }
    return cursor;
}
