//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      PDialog.cpp
//

#include "PDialog.hpp"
#include "psec.hpp"
#include "Softkey.hpp"

#define     TOP_MARGIN              (1)
#define     PANE_NAME               ("Environment setting")
#define     LABEL_SOFTKEY1          ("Back")
#define     LABEL_SOFTKEY2          ("Finish")
#define     LABEL_SOFTKEY3          ("Select")

PDialog::PDialog(Void) static_throws : SFRPlainDialog(SFXRectangle(0, 0, 0, 0), BEHAVIOR_SFRPLAINDIALOG, ATTRIBUTE_PDIALOG)
{
    SoftkeyPtr softkey;
    SFRTabControlPtr tab;
    SFRTabPanePtr pane;
    SFXRectangle rect;

    Softkey::Initialize(this);
    if (static_try()) {
        static_throw(RegisterHandler(static_cast<SFCEventEnum>(Softkey::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
        if (static_try()) {
            SetBaseBound(psec::CalculateWindowPosition());
            rect = GetContentWorld();
            rect.AddTop(TOP_MARGIN);
            if ((tab = ::new SFRTabControl(this, rect)) != null) {
                static_throw(*tab);
                if (static_try()) {
                    if ((pane = ::new SFRTabPane(tab, PANE_NAME)) != null) {
                        static_throw(*pane);
                        if (static_try()) {
                            Select();
                            if ((softkey = Softkey::GetInstance()) != null) {
                                static_throw(softkey->Register(this, Softkey::SOFTKEY_1, LABEL_SOFTKEY1));
                                if (static_try()) {
                                    static_throw(softkey->Register(this, Softkey::SOFTKEY_2, LABEL_SOFTKEY2));
                                    if (static_try()) {
                                        static_throw(softkey->Register(this, Softkey::SOFTKEY_3, LABEL_SOFTKEY3));
                                        if (static_try()) {
                                            SetReference(softkey->Bind(this));
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else {
                        static_throw(SFERR_NO_MEMORY);
                    }
                }
            }
            else {
                static_throw(SFERR_NO_MEMORY);
            }
        }
    }
    return;
}

PDialog::~PDialog(Void)
{
    Softkey::Terminate(this);
    return;
}

HANDLER_IMPLEMENT_VOIDEVENT(PDialog, OnSoftkey, event)
{
    switch (event.GetP16()) {
        case Softkey::SOFTKEY_1:
            Invoke(SFXEvent(SREVT_DIALOG, SRP16_CANCEL, reinterpret_cast<UInt32>(this)));
            break;
        case Softkey::SOFTKEY_2:
            Invoke(SFXEvent(SREVT_DIALOG, SRP16_OK, reinterpret_cast<UInt32>(this)));
            break;
    }
    return;
}
