//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      Softkey.hpp
//

#ifndef __SOPHIACRADLE_SOFTKEY_HPP
#define __SOPHIACRADLE_SOFTKEY_HPP

#include <SophiaFramework.hpp>

SFMRESPONDERATTRIBUTE(SOFTKEY, four_char_code('S', 'o', 'f', 't'))

SFMTYPEDEFCLASS(Softkey)
class Softkey : public SFRPlainWindow {

    SFMSEALCOPY(Softkey)

    public:

        enum {
            USEREVT_SOFTKEY = SFEVT_USER + 0x0100
        };
        enum SoftkeyEnum {
            SOFTKEY_1,
            SOFTKEY_2,
            SOFTKEY_3,
            SOFTKEY_LIMIT
        };

    private:

        SFMTYPEDEFSTRUCT(ItemRec)
        struct ItemRec {
            SFRResponderPtr responder;
            SFXWideString label[SOFTKEY_LIMIT];
            Bool enable[SOFTKEY_LIMIT];
        };

    private:

        SFXList<ItemRecPtr> _item;
        SFRResponderPtr _bind;

    public:

        explicit Softkey(SFRApplicationPtr director) static_throws;
        virtual ~Softkey(Void);

        static SoftkeyPtr GetInstance(Void);
        SFRResponderPtr Bind(SFRResponderPtr responder);
        SFCError Register(SFRResponderPtr responder, SoftkeyEnum index, SFXWideStringConstRef label, Bool enable = true);
        Void Unregister(SFRResponderPtr responder);
        static Void Initialize(SFRResponderPtr responder);
        static Void Terminate(SFRResponderPtr responder);

    private:

        HANDLER_DECLARE_VOIDRENDER(OnRender)
        HANDLER_DECLARE_BOOLEVENT(OnSoftkey)
        Void DrawButton(SFXGraphicsPtr graphics, SFXRectangleConstRef rect, SFXWideStringConstRef string);
        ItemRecPtr Find(SFRResponderPtr responder) const;
};

#endif // __SOPHIACRADLE_SOFTKEY_HPP //
