//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      TNKeyboard.cpp
//

#include "TNKeyboard.hpp"
#include "TSKeyboard.hpp"
#include "FNKeyboard.hpp"

TNKeyboard::TNKeyboard(SFRApplicationPtr director, SFXRectangleConstRef rect, MonitorPtr monitor, CalculatorPtr calculator) static_throws : Keyboard(director, rect, ATTRIBUTE_TNKEYBOARD, monitor, calculator)
{
    if (static_try()) {
        Refresh();
    }
    return;
}

TNKeyboardPtr TNKeyboard::GetInstance(Void)
{
    return static_cast<TNKeyboardPtr>(Keyboard::GetInstance(ATTRIBUTE_TNKEYBOARD));
}

Void TNKeyboard::HandlerClear(Void)
{
    Return();
    return;
}

Void TNKeyboard::Handler1(Void)
{
    GetCalculator()->Function_sin();
    Return();
    return;
}

Void TNKeyboard::Handler2(Void)
{
    GetCalculator()->Function_cos();
    Return();
    return;
}

Void TNKeyboard::Handler3(Void)
{
    GetCalculator()->Function_tan();
    Return();
    return;
}

Void TNKeyboard::Handler4(Void)
{
    GetCalculator()->Function_sinh();
    Return();
    return;
}

Void TNKeyboard::Handler5(Void)
{
    GetCalculator()->Function_cosh();
    Return();
    return;
}

Void TNKeyboard::Handler6(Void)
{
    GetCalculator()->Function_tanh();
    Return();
    return;
}

Void TNKeyboard::HandlerStar(Void)
{
    Return();
    return;
}

Void TNKeyboard::Handler0(Void)
{
    KeyboardPtr keyboard;

    if ((keyboard = FNKeyboard::GetInstance()) != null) {
        keyboard->Activate(this);
    }
    return;
}

Void TNKeyboard::HandlerPound(Void)
{
    KeyboardPtr keyboard;

    if ((keyboard = TSKeyboard::GetInstance()) != null) {
        keyboard->Activate(this);
    }
    return;
}

Void TNKeyboard::Refresh(Void)
{
    static MapRecConst map = {{
        {         MAP_UNDEFINED,                MAP_RTN,                MAP_OFF},
        {{ "sin", COLOR_NORMAL}, { "cos", COLOR_NORMAL}, { "tan", COLOR_NORMAL}},
        {{"sinh", COLOR_NORMAL}, {"cosh", COLOR_NORMAL}, {"tanh", COLOR_NORMAL}},
        {         MAP_UNDEFINED,          MAP_UNDEFINED,          MAP_UNDEFINED},
        {               MAP_VAL,                MAP_STD,                MAP_SFT}
    }};

    Keyboard::Refresh(map);
    return;
}

Void TNKeyboard::Activate(KeyboardPtr inactivate)
{
    Keyboard::Activate(inactivate, Monitor::MODE_FUNCTION | Monitor::MODE_TRIGONOMETRIC);
    return;
}
