//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      VSKeyboard.hpp
//

#ifndef __SOPHIACRADLE_VSKEYBOARD_HPP
#define __SOPHIACRADLE_VSKEYBOARD_HPP

#include <SophiaFramework.hpp>
#include "Keyboard.hpp"

SFMRESPONDERATTRIBUTE(VSKEYBOARD, four_char_code('V', 'S', 'k', 'y'))

SFMTYPEDEFCLASS(VSKeyboard)

class VSKeyboard : public Keyboard {

    SFMSEALCOPY(VSKeyboard)

    public:

        explicit VSKeyboard(SFRApplicationPtr director, SFXRectangleConstRef rect, MonitorPtr monitor, CalculatorPtr calculator) static_throws;
        static VSKeyboardPtr GetInstance(Void);

    private:

        virtual Void HandlerClear(Void);
        virtual Void Handler1(Void);
        virtual Void Handler2(Void);
        virtual Void Handler3(Void);
        virtual Void Handler4(Void);
        virtual Void Handler5(Void);
        virtual Void Handler6(Void);
        virtual Void Handler7(Void);
        virtual Void Handler8(Void);
        virtual Void Handler9(Void);
        virtual Void HandlerStar(Void);
        virtual Void Handler0(Void);
        virtual Void HandlerPound(Void);
        virtual Void Refresh(Void);
        virtual Void Activate(KeyboardPtr inactivate);
};

#endif // __SOPHIACRADLE_VSKEYBOARD_HPP //
