//
//     Copyright (C) 2006 - 2007 SophiaCradle, Inc.
//     All rights reserved.
//
//      psec.hpp
//

#ifndef __SOPHIACRADLE_PSEC_HPP
#define __SOPHIACRADLE_PSEC_HPP

#include <SophiaFramework.hpp>
#include "psec.bid"
#include "Calculator.hpp"

SFMTYPEDEFCLASS(psec)
class psec : public SFRApplication {

    SFMSEALCOPY(psec)

    private:

        CalculatorPtr _calculator;
#if defined TARGET_ENVIRONMENT_PHYSICAL
#if TARGET_VERSION_LT(3, 1, 0)
        SFBFontSmp _font;
        SFBFontPtr _native;
#endif
#endif

    public:

        static SFCInvokerPtr Factory(Void);
        static SFXRectangle CalculateWindowPosition(Void);
        static SFXRectangle CalculateDialogPosition(SFXMarginConstRef margin, SInt16 height);
        static SFXRectangle CalculateMenuPosition(SInt16 limit);
        static SFCError OpenStandardDialog(SFRDialogPtr dialog, SFRHandlerSPP procedure, VoidPtr reference);
        static Void CloseStandardDialog(SFRDialogPtr dialog);
        static SFCError OpenCustomDialog(SFRDialogPtr dialog, SFRHandlerSPP procedure, VoidPtr reference);
        static Void CloseCustomDialog(SFRDialogPtr dialog);
        static SFCError OpenStandardMenu(SFRMenuPtr menu, SFRHandlerSPP procedure, VoidPtr reference);
        static Void CloseStandardMenu(SFRMenuPtr menu);

    private:

        explicit psec(Void) static_throws;
        virtual ~psec(Void);

        HANDLER_DECLARE_VOIDRENDER(OnRender)
        HANDLER_DECLARE_VOIDSTART(OnStart)
        HANDLER_DECLARE_VOIDSTOP(OnStop)
        HANDLER_DECLARE_VOIDEVENT(FromMessage)
        static Bool OnSoftkeySHP(SFXEventConstRef event, VoidPtr reference);
};

#endif // __SOPHIACRADLE_PSEC_HPP //
